void   error(char error_text[]);
short  *ivector(long n);
void   free_ivector(short *v);
double *dvector(long n);
void   free_dvector(double *v);

short  mpadd(short w[], short u[], short v[], int n);
short  mpsub(short w[], short u[], short v[], int n);
short  mpsad(short w[], short u[], int n, int iv);
short  mpssu(short w[], short u[], int n, int iv);
short  mpsmu(short w[], short u[], int n, int iv);
short  mpsdv(short w[], short u[], int n, int iv);
short  mpneg(short u[], int n);
void   mpmov(short u[], short v[], int n);
void   mplsh(short u[], int n);
void   mpclr(short u[], int n);

void   halfmul(short w[], short u[], short v[], int n, int m, int flags);
void   fullmul(short w[], short u[], short v[], int n, int m, int flags);
void   mpsqrt(short y[], short x[], short a[], int n);
void   mpinv(short x[], short a[], int n);

#define NOP 0
#define LSH 2
#define STO 4
#define RCL 8
